<nz-page-header nzBackIcon>
  <!-- <nz-breadcrumb nz-page-header-breadcrumb>
    <nz-breadcrumb-item><a routerLink="/">{{ "Common.Homepage" | translate }}</a></nz-breadcrumb-item>
    <nz-breadcrumb-item>{{ "Politics.Elections.ElectionsResults" | translate }}</nz-breadcrumb-item>
  </nz-breadcrumb> -->

  <nz-page-header-title>{{ "Politics.Elections.electionsResults" | translate }}</nz-page-header-title>
</nz-page-header>
<nz-divider></nz-divider>

<nz-spin [nzSpinning]="isLoading">
  <div nz-row nzJustify="space-around" nzGutter="12" style="margin-bottom: 20px">
    <div nz-col nzXs="24" nzSm="24" nzLg="7">
      <h4 style="text-align: center">
        {{ "Politics.Elections.SelectElectionType" | translate }}
      </h4>
      <nz-select [(ngModel)]="selectedElectionType" style="width: 100%" [required]
        (ngModelChange)="selectedElectionDate = undefined; electionData = undefined; ">
        <nz-option *ngFor="let type of electionTypes" [nzLabel]="type.name" [nzValue]="type">
        </nz-option>
      </nz-select>
    </div>

    <div nz-col nzXs="24" nzSm="24" nzLg="7">
      <h4 style="text-align: center">
        {{ "Citizen.SelectCountry" | translate }}
      </h4>
      <nz-select nzShowSearch nzAllowClear nzPlaceHolder="Select country" style="width: 100%"
        [nzCustomTemplate]="countrySelectTemplate" [(ngModel)]="selectedCountry" (ngModelChange)="getElection()">
        <nz-option *ngFor="let item of countries" nzCustomContent [nzLabel]="item.name" [nzValue]="item">
          <img [src]="item.flagLocation" width="30" height="20" />
          {{ item.name | translate }}
        </nz-option>
      </nz-select>
      <ng-template #countrySelectTemplate>
        <img src="{{ selectedCountry?.flagLocation }}" width="30" height="20" />
        {{ selectedCountry?.name | translate }}
      </ng-template>
    </div>

    <div nz-col nzXs="24" nzSm="24" nzLg="7">
      <h4 style="text-align: center">
        {{ "Politics.Elections.SelectDay" | translate }}
      </h4>
      <nz-select *ngIf="selectedElectionType" [(ngModel)]="selectedElectionDate" style="width: 100%"
        (ngModelChange)="getElection()">
        <nz-option *ngFor="let item of selectedElectionType.list" [nzValue]="item.id"
          nzLabel="Day {{ item.finishGameDay }}"></nz-option>
      </nz-select>
    </div>
  </div>


  <div *ngIf="electionData">
    <nz-divider></nz-divider>
    <h3 nz-title>{{ "Politics.Elections.CandidatesAndWinners" | translate }}</h3>

    <div *ngIf="electionData.length === 0" style="text-align: center">
      <nz-alert nzType="warning" nzMessage='{{ "Politics.Elections.noCandidatesApplied" | translate }}'></nz-alert>
    </div>

    <div *ngIf="electionData.length > 0">
      <div *ngIf="selectedElectionType.type !== 2">
        <ng-container [ngTemplateOutlet]="candidatesTable" [ngTemplateOutletContext]="{data:electionData}">
        </ng-container>
      </div>

      <div *ngIf="selectedElectionType.type === 2">
        <div *ngFor="let party of electionData">
          <h3 nz-title>{{ "Politics.Elections.Party" | translate }}: {{ party.party.name }}</h3>

          <ng-container [ngTemplateOutlet]="candidatesTable" [ngTemplateOutletContext]="{data:party.candidates}">
          </ng-container>
        </div>
      </div>
      <div *ngIf="pieData">
        <div nz-row nzGutter="8" nzAlign="middle" nzJustify="center">
          <div nz-col nzSpan="18">
            <app-chart *ngIf="pieLabels.length" [labels]="pieLabels" [datasets]="pieData" type="pie"></app-chart>
          </div>
        </div>
      </div>
    </div>
  </div>
</nz-spin>


<ng-template #candidatesTable let-data='data'>
  <nz-table #electionsTable nzSize="middle" [nzData]="data" [nzLoading]="isLoading">
    <thead>
      <tr>
        <th>{{ "Politics.Elections.Place" | translate }} #</th>
        <th>{{ "Politics.Elections.CandidateName" | translate }}</th>
        <th *ngIf="selectedElectionType?.key != 'PartyPresident'">{{ "Politics.Elections.Party" | translate }}</th>
        <th>{{ "Social.Newspaper.Votes" | translate }}</th>
        <th>{{ "Politics.Elections.HasWon" | translate }}?</th>
      </tr>
    </thead>
    <tbody>
      <tr *ngFor="let electionPosition of data; index as i">
        <td>
          {{ i + 1 }}
        </td>
        <td>
          <nz-avatar [nzIcon]="'user'" [nzSrc]="electionPosition?.candidate?.avatar" style="margin-right: 5px">
          </nz-avatar>
          {{ electionPosition?.candidate?.name }}
        </td>
        <td *ngIf="selectedElectionType?.key != 'PartyPresident'">
          {{ electionPosition?.party?.name }}
        </td>
        <td>
          {{ electionPosition?.votes }}
        </td>
        <td>
          <nz-tag *ngIf="electionPosition.winType === 'ByPartyVotes'" [nzColor]="'green'">{{ "Common.Yes" | translate }} ({{
            "Politics.Elections.PartyVotes" | translate }})</nz-tag>
          <nz-tag *ngIf="electionPosition.winType === 'ByVotes'" [nzColor]="'green'">{{ "Common.Yes" | translate }} ({{
            "Social.Newspaper.Votes" | translate }})</nz-tag>
          <nz-tag *ngIf="electionPosition.winType === 0" [nzColor]="'red'">{{ "Common.No" | translate }}</nz-tag>
        </td>
      </tr>
    </tbody>
  </nz-table>
</ng-template>
